#! /usr/bin/env python3

import chipwhisperer as cw
import numpy as np
import matplotlib.pyplot as plt
import time
import os
import sys
from workbench import Device
from workbench import WorkBench
import random

class capture_configuration:
    samples = 2000
    traces  = 1000
        
config = capture_configuration()
local_config = dict()

wb = WorkBench(local_config.get('workbench', dict()),0)
wb.upload_firmware('firmware.hex')
wb.reset()
wb.config_capture(config.samples)

random_traces  = np.zeros((config.traces,config.samples))
random_res     = np.zeros(config.traces,dtype = "object")
    
fixed_traces  = np.zeros((config.traces,config.samples))
fixed_res     = np.zeros(config.traces,dtype = "object")

print('Capture traces')

# Random traces
for trace_id in range(config.traces):
    in_buffer = np.array([random.randrange(2**32)], dtype=np.uint32)
    wb.write('c')
    wb.arm()
    wb.write_buffer(in_buffer)
    wb.capture()
    random_traces[trace_id] = wb.get_last_trace()

# Fixed traces
for trace_id in range(config.traces):
    in_buffer = np.array([1234], dtype=np.uint32)
    wb.write('c')
    wb.arm()
    wb.write(in_buffer)
    wb.capture()
    fixed_traces[trace_id] = wb.get_last_trace()

## Code à compléter
